+ String {

	block_format {
		// Format with smart line breaks (for long blocks of text).

		arg
			oldText = "",
			lineLength = 40,
			numLines = 16,
			indent = "> ";
		var
			breakLine,
			charNum,
			lines,
			nextIndent,
			textBlock,
			newText;
			
		breakLine = false;

		charNum = indent.size;

		nextIndent = "";
		indent.size.do{
			nextIndent = nextIndent ++ " ";
		};


		textBlock = indent;

		this.do{
			arg i;

			if(
				breakLine,
				{
					textBlock = textBlock ++ "\n" ++ nextIndent;
					breakLine = false;
				}
			);

			if(
				i != $\n,
				{
					textBlock = textBlock ++ i;
				}
			);
			
			if(
				(i == $\n) || (charNum == lineLength),
				{
					breakLine = true;
					charNum = indent.size;
				},
				{
					charNum = charNum + 1;
				}					
			);

		};

		lines = (oldText ++ textBlock).split($\n);
		newText = "";
		(max(0, lines.size - numLines) .. lines.size - 1).do {
			arg i;
			newText = newText ++ lines[i] ++ "\n";
		};

		^ newText	
	}
	
	is_valid_plork_cmd {
		// 

		var string = "!" ++ this; // 

		if(
			"^![afimM]$".matchRegexp(string),
			{
				^true
			},
			{
				^false
			}
		);	
	
	}
	
	is_valid_number {
		// String.matchRegexp bug: whatever.matchRegexp(oneCharacterString) returns `false`
		
		var string = "!" ++ this; // Band-Aid

		if(
			"^![0-9]*(\\.[0-9]*)?$".matchRegexp(string),
			{
				^true
			},
			{
				^false
			}
		);	
	
	}
	
	is_valid_time_format {
		var min, sec, frac;		
		
		if(
			"^[0-9]?[0-9]:[0-9][0-9](\\.[0-9]*)?$".matchRegexp(this),
			// N.B. double \\ for backslash
			{
				sec = this.split($:).at(1);
				if (
					sec.asInteger < 60,
					{		
						^true
					},
					{
						^false
					}
				);
					
			},
			{
				^false
			}
		)

	}
	
	to_time_float {
		var min, sec;

		# min, sec = this.split($:);
		^ 60 * min.asInteger + sec.asFloat;
	}
	
	to_rounded_time {
		var min_sec, fraction;
		#min_sec, fraction = this.split($.);

		^min_sec
	}

	pad_floatString {
		// Assume reasonable input, i.e.
		// int values with optional fractional part: [0-9]+(\.[0-9]+)?
		
		arg len = 5, char = " ";
		var splitStr, newStr;

		// Split the string and add padding characters.
		splitStr = this.split($.);

		while(
			{splitStr[0].size < len},
			{
				splitStr[0] = char ++ splitStr[0]
			}
		
		);
		
		// Reconcatenate the string.
		newStr = "";
		splitStr.do{
			arg i;
			newStr = newStr ++ i ++ ".";
		};
		
		// chomp last "."
		newStr.pop;
		
		^newStr
	}
	
}