SynthWindow {
	var
		<>window,
		<>synthDisplay,
		<>oscResp;
				
	*new {
		arg playerNum;
		^super.new.init(playerNum);
	}


	init {
		arg playerNum;
		
		this.init_osc_responder(playerNum);
		
		/* Window. */
		window = Window(
			"SynthWindow",
			Rect(320, 400, 320, 160),
			resizable: false
		);
		
		window.view.background = Color.black;
		window.front;
		CmdPeriod	.add({window.close});

		synthDisplay = SynthDisplay(
			window,
			window.view.bounds.insetBy(10)
		);

	}

	init_osc_responder {
		arg playerNum;

		oscResp = OSCresponderNode(
			NetAddr("0.local", 57120), // address of conductor
			'/synth',
			{
				arg
					time,
					resp,
					msg;
				var
					parameter,
					value;

				parameter = msg[1];
				value = msg[2];
				
				parameter.switch(
					\amp, {this.set_amp(value)},
					\impulseFreq, {this.set_freq(value)},
					{
						"Warning: SynthWindow doesn't understand this parameter: " ++
						parameter.asString
					}
				);
			}
		).add;
		
		// Remove the OSC responder when done.
		CmdPeriod	.add({oscResp.remove});
		
	}
	
	set_amp {
		arg i;
		synthDisplay.set_amp(i);
	}
	
	set_freq {
		arg i;
		synthDisplay.set_freq(i);
		
	}
	
}