CodingWindow {

	var
		<>messageField,
		<>window;
		
	*new {
		arg
			playerNum;
		^super.new.init(playerNum);
	}
	
	init {
		arg
			playerNum;
		var
			conductorAddr,
			font,
			w,
			h,
			y;
			

		conductorAddr = NetAddr(
			"0.local",
			57120
		); 

		/* Window. */
		window = Window(
			"CodingWindow",
			Rect(0, 400, 320, 160),
			resizable: false
		);

		// Window dimension variables
		w = window.view.bounds.width;
		h = window.view.bounds.height;
		y = 24;
		
		window.view.background = Color.green;
		window.front;
		CmdPeriod	.add({window.close});

		/* Field for typing messages. */
		font = Font("Monaco", 10);

		messageField = TextField(window, window.view.bounds.insetBy(10));
		
		messageField.background = Color.green;
		messageField.stringColor = Color.black;
		messageField.font = font;
		messageField.string = "Type messages here.";
		messageField.action = {
			arg i;

			// Send messages to the conductor.
			conductorAddr.sendBundle(
				0,
				[
					'/conductor',
					i.string
				]
			);

			// Erase the field.			
			i.string = "";
		};
		
/*
		/* KeyDownAction and KeyUpAction: send data directly to the KeyboardWindow. */
		messageField.keyDownAction = {
			arg view, char, modifiers, unicode, keycode;
			conductorAddr.sendBundle(
				0,
				[
					'/keyboardWindow',
					\keyDown,
					char.asSymbol
				]
			)
		};
		
		messageField.keyUpAction = {
			arg view, char, modifiers, unicode, keycode;
			conductorAddr.sendBundle(
				0,
				[
					'/keyboardWindow',
					\keyUp,
					char.asSymbol
				]
			)
		};
		
		// 110208: nixed the KeyboardWindow, swapped in the CharWindow
*/

		// keyDownAction: send data directly to the CharWindow.
		messageField.keyDownAction = {
			arg view, char, modifiers, unicode, keycode;
			conductorAddr.sendBundle(
				0,
				[
					'/charWindow',
					char.asSymbol
				]
			)
		}
	}	
}
