Chord {
	var
		<>startTimes,
		<>endTimes,
		<>playerNums,
		<>freqs;
	
	*new {
		arg
			startTimes,
			endTimes,   // a nil keeps the voice from turning off
			playerNums,
			freqs;
			
			
		^super.newCopyArgs(
			startTimes,
			endTimes,
			playerNums,
			freqs
		);
	}
	
	*from_numeral {
		arg
			startTimes,
			endTimes,
			playerNums,
			numeral;
		var
			chordDict,
			freqs;

		// Make a Dictionary of numeral keys and frequency values.
		// 60 Hz glitch, etc.
		chordDict = Dictionary[
			1 -> (4410 + [6, 24, 30, 36]),   // I
			4 -> (4410 + [8, 24, 32, 40]),   // IV
			5 -> (4410 + [9, 22.5, 27, 36]), // V
			6 -> (4410 + [10, 24, 30, 40])   // vi
		];
		
		freqs = chordDict.at(numeral);
		
		^super.newCopyArgs(
			startTimes,
			endTimes,
			playerNums,
			freqs
		)
	}
	
	as_msg_lists {
		var
			msgLists;
		
		msgLists = all {: [], i <- (0..7) };
		
		playerNums.do{
			arg i, index;

			msgLists[i] = [
				"% % +".format(
					startTimes[index].asTimeString(0.0001),
					freqs[index].asString
				)
			];
			if(
				endTimes[index] != nil,
				{				
					msgLists[i] = msgLists[i] ++ [ 
						"% -".format(
							endTimes[index].asTimeString(0.0001)
						)
					]
				}
			);
		};
		
		^msgLists
	
	}
}