Hocket {
	var
		startTime,
		endTime,
		freqRange,
		playerOrder,
		evenness,
		ampString,
		changeFreq;

	*new {
		arg
			startTime,
			endTime,
			freqRange,
			playerOrder,
			evenness,
			ampString = ["+", "-"],   // one entry for each of a
			                            // segment's two time points
			changeFreq = [true, false]; // ditto

		^super.newCopyArgs(
			startTime,
			endTime,
			freqRange,
			playerOrder,
			evenness,
			ampString,
			changeFreq;
		)
	}
	
	as_msg_lists {
		var
			numSegments,
			msgLists,
			timePoints,
			freqRand;

		numSegments = playerOrder.size;
		msgLists = all {: [], i <- (0..7) };
		timePoints = Array.new(numSegments + 1);
		timePoints.add(startTime);

		(1 .. numSegments - 1).do{
			arg i;
			var point, dur;
			
			dur = endTime - startTime;
			point = i * dur / numSegments + startTime;
			timePoints.add(this.set_time_point(point));
		};
		
		timePoints.add(endTime);
		timePoints.sort;	
	
		playerOrder.do{
			arg player, i;
			var
				freqRand,
				segmentTimePoints, // [segment start time, segment end time]
				msgs = Array.newClear(2);

			segmentTimePoints = timePoints[i..i+1];

			2.do{
				arg j;							
				var
					freqString;
				
				if(
					changeFreq[j],
					{
						freqString = rrand(
							freqRange[0],
							freqRange[1]
						).round(0.001).asString
					},
					{
						freqString = ""
					}
				);
				
				msgs[j] = segmentTimePoints[j].asTimeString(0.0001) ++ " " ++
				freqString ++ " " ++
				ampString[j];
			};
			
			msgLists[player] = msgLists[player] ++ msgs;
		};
	
		^msgLists
	
	}
	
	set_time_point {
		arg i;
		
		^rrand(
			ControlSpec(startTime, i).map(evenness),
			ControlSpec(endTime, i).map(evenness)
		).round(0.001);
	
	}
	

}