Polyrhythms {
	var
		startTimes,
		endTimes,
		playerNums,
		numPulses;

	*new {
		arg
			startTimes,
			endTimes,
			playerNums,
			numPulses;
		^super.newCopyArgs(
			startTimes,
			endTimes,
			playerNums,
			numPulses
		);
	}
	
	as_msg_lists {
		var
			msgLists;
			
		msgLists = all {: [], i <- (0..7) };

		playerNums.do{
			arg i, index;
			var dur;
			
			dur = endTimes[index] - startTimes[index];

			numPulses[index].do{
				arg j;
				var onPoint, offPoint;
								
				onPoint = dur * j / numPulses[index] + startTimes[index];
				offPoint = dur * (j + 0.5) / numPulses[index] + startTimes[index];

				msgLists[i] = msgLists[i] ++
				[
					"% +".format(onPoint.asTimeString(0.001)),
					"% -".format(offPoint.asTimeString(0.001))
				]
			}
		};


		^msgLists

	}
	
}