ImpulseSynth {
	var
		<>synth,
		<>amp,
		<>impulseFreq;
				
	*new {
		arg
			simulation = false,
			pan = 0;
			
		^super.new.init(simulation, pan);
	}
	
	init {
		arg
			simulation,
			pan;
	
		amp = 0;
		impulseFreq = 4410;
	
		Server.local.waitForBoot(
			{
	
				SynthDef.new(
					"impulseSynth",
					{
						arg
							amp,
							impulseFreq,
							pan;
						var
							impulse;
						
						impulse = Impulse.ar(impulseFreq, 0, amp);
						if(
							simulation,
							{
								Out.ar(0, Pan2.ar(impulse, pan, 0.25))
							},
							{
								Out.ar(0, impulse ! 6)
							}
						);
					}
				).send(Server.local);
				0.5.wait;
				
				// Load the synth.
				synth = Synth.new("impulseSynth");
				0.1.wait;
				
				// Initialize values.
				if(
					simulation,
					{
						synth.set(\pan, pan)
					}
				);


				this.set_amp(amp);
				this.set_freq(impulseFreq);

				

			};	
		);	
	}

	set_amp {
		arg i;
		amp = i;
		synth.set(\amp, i);
	}
	
	set_freq {
		arg i;
		impulseFreq = i;
		synth.set(\impulseFreq, i);
	}
		
	off {
		synth.free;
	}
}