SynthDisplay {

	var

		<>synth,
		<>text;		
				
	*new {
		arg
			parent,
			bounds;
		^super.new.init(parent, bounds);
	}


	init {
		arg
			parent,
			bounds;
		
		text = StaticText(parent, bounds);
		text.background = Color.red;
		text.align = \center;
		text.font = Font("Monaco", 10);
		text.string = (
			"Booting the sound server.\n" ++
			"If this button stays red\n" ++
			"for more than 10 seconds,\n" ++
			"press command-k to reboot."
		);
		text.stringColor = Color.black;

		/* Load synth. */
		Server.local.waitForBoot(
			{
				synth = ImpulseSynth.new;		
				// Initialize values.
				this.set_amp(synth.amp);
				this.set_freq(synth.impulseFreq);
				// Change the background color to let
				// the player know sound is working
				text.background = Color.black;
			}
		);
	}
	
	set_amp {
		arg amp;
		synth.set_amp(amp);
		{this.set_string_color}.defer;
	}
	
	set_freq {
		arg freq;
		synth.set_freq(freq);
		{text.string = freq.asString}.defer;
	}


	set_string_color {
		// Set the text color to red if the amp is 0, or green if otherwise.
		
		if(
			synth.amp == 0,
			{
				text.stringColor = Color.red
			},
			{
				text.stringColor = Color.green

			}
		);
	}

}