ConductorBundle {
	var
		// button to start and stop the piece	
		<>conductorWindow,
		// graphics for public display
		<>charWindow,
		<>msgWindow,
		<>freqTablesWindow;
		
	*new {
		arg
			numPlayers,
			projection = false,
			thisScreenWidth = 1280,
			projectionScreenWidth = 1280,
			displayHeight = 720;
			
		^super.new.init(
			projection,
			numPlayers,
			thisScreenWidth,
			projectionScreenWidth,
			displayHeight
		);
	}
	
	init {
		arg
			projection,
			numPlayers,
			thisScreenWidth,
			projectionScreenWidth,
			displayHeight;

		msgWindow = MsgWindow(
			playerNum: 0,
			public: true,
			projection: projection,
			thisScreenWidth: thisScreenWidth,
			projectionScreenWidth: projectionScreenWidth,
			displayHeight: displayHeight
		);
		charWindow = CharWindow(
			numPlayers,
			projection,
			thisScreenWidth,
			projectionScreenWidth,
			displayHeight
		);
		freqTablesWindow = FreqTablesWindow(
			numPlayers,
			projection,
			thisScreenWidth,
			projectionScreenWidth,
			displayHeight			
		);
		conductorWindow = ConductorWindow(numPlayers);
	}
}